// BST main can be re-used for hash table (they're both dictionaries)

#include "book.h"
#include "hashdict.h"

int main()
{
    // One way to have empty and tomb flags for any templated type is to have the user set them,
    // as the -1 and -2 below
    // can make value a non-pointer, but the nullptr checks break
    hashdict<int, string *> intDict(100, -1, -2);

    intDict.insert(700, new string("Lettuce"));
    intDict.insert(350, new string("Apple"));
    intDict.insert(201, new string("Orange"));
    intDict.insert(170, new string("Starfruit"));
    intDict.insert(151, new string("Beet"));
    intDict.insert(190, new string("Radish"));
    intDict.insert(1000, new string("Cucumber"));
    intDict.insert(900, new string("Kale"));
    intDict.insert(950, new string("Rutabaga"));
    intDict.insert(10, new string("Pumpkin"));
    intDict.insert(300, new string("Carrot"));
    
    intDict.remove(300);
    intDict.remove(10);

    intDict.size();

    intDict.find(900);
    intDict.find(10);

    intDict.insert(130, new string("Papaya"));
    
    while(intDict.size() != 0)
        cout << *(intDict.removeAny()) << endl;

    return 0;
}

